src/locktest: Change command macro names
[xfstests-dev.git] / check
diff --git a/check b/check
index e4d767375b57ba758aa50760b39f75da53a0363a..c7f1dc5ee271536e25d3b3ad529f654b7b87c2f8 100755 (executable)
--- a/check
+++ b/check
@@ -52,14 +52,14 @@ usage()
     echo "Usage: $0 [options] [testlist]"'
 
 check options
-    -nfs                test NFS
-    -glusterfs                test GlusterFS
-    -cifs               test CIFS
+    -nfs               test NFS
+    -glusterfs         test GlusterFS
+    -cifs              test CIFS
     -9p                        test 9p
     -overlay           test overlay
-    -pvfs2          test PVFS2
-    -tmpfs              test TMPFS
-    -ubifs              test ubifs
+    -pvfs2             test PVFS2
+    -tmpfs             test TMPFS
+    -ubifs             test ubifs
     -l                 line mode diff
     -udiff             show unified diff (default)
     -n                 show me, do not run tests
@@ -130,6 +130,7 @@ get_group_list()
        local grp=$1
        local grpl=""
        local sub=$(dirname $grp)
+       local fsgroup="$FSTYP"
 
        if [ -n "$sub" -a "$sub" != "." -a -d "$SRC_DIR/$sub" ]; then
                # group is given as <subdir>/<group> (e.g. xfs/quick)
@@ -138,7 +139,10 @@ get_group_list()
                return
        fi
 
-       for d in $SRC_GROUPS $FSTYP; do
+       if [ "$FSTYP" = ext2 -o "$FSTYP" = ext3 ]; then
+           fsgroup=ext4
+       fi
+       for d in $SRC_GROUPS $fsgroup; do
                if ! test -d "$SRC_DIR/$d" ; then
                        continue
                fi
@@ -242,13 +246,17 @@ _prepare_test_list()
        done
 
        # sort the list of tests into numeric order
-       list=`sort -n $tmp.list | uniq`
-       rm -f $tmp.list
-
-       if $randomize
-       then
-               list=`echo $list | awk -f randomize.awk`
+       if $randomize; then
+               if type shuf >& /dev/null; then
+                       sorter="shuf"
+               else
+                       sorter="awk -v seed=$RANDOM -f randomize.awk"
+               fi
+       else
+               sorter="cat"
        fi
+       list=`sort -n $tmp.list | uniq | $sorter`
+       rm -f $tmp.list
 }
 
 # Process command arguments first.
@@ -479,9 +487,8 @@ _check_filesystems()
        if [ -f ${RESULT_DIR}/require_scratch ]; then
                _check_scratch_fs || err=true
                rm -f ${RESULT_DIR}/require_scratch*
-       else
-               _scratch_unmount 2> /dev/null
        fi
+       _scratch_unmount 2> /dev/null
 }
 
 _expunge_test()
@@ -496,7 +503,18 @@ _expunge_test()
        return 0
 }
 
-_init_kmemleak
+# Make the check script unattractive to the OOM killer...
+OOM_SCORE_ADJ="/proc/self/oom_score_adj"
+test -w ${OOM_SCORE_ADJ} && echo -1000 > ${OOM_SCORE_ADJ}
+
+# ...and make the tests themselves somewhat more attractive to it, so that if
+# the system runs out of memory it'll be the test that gets killed and not the
+# test framework.
+_run_seq() {
+       bash -c "test -w ${OOM_SCORE_ADJ} && echo 250 > ${OOM_SCORE_ADJ}; exec ./$seq"
+}
+
+_detect_kmemleak
 _prepare_test_list
 
 if $OPTIONS_HAVE_SECTIONS; then
@@ -538,6 +556,13 @@ for section in $HOST_OPTIONS_SECTIONS; do
                fi
        fi
 
+       mkdir -p $RESULT_BASE
+       if [ ! -d $RESULT_BASE ]; then
+               echo "failed to create results directory $RESULT_BASE"
+               status=1
+               exit
+       fi
+
        if $OPTIONS_HAVE_SECTIONS; then
                echo "SECTION       -- $section"
        fi
@@ -614,6 +639,8 @@ for section in $HOST_OPTIONS_SECTIONS; do
              echo "check: failed to mount \$SCRATCH_DEV using specified options"
              status=1
              exit
+         else
+             _scratch_unmount
          fi
        fi
 
@@ -726,12 +753,13 @@ for section in $HOST_OPTIONS_SECTIONS; do
                        # _check_dmesg depends on this log in dmesg
                        touch ${RESULT_DIR}/check_dmesg
                fi
+               _try_wipe_scratch_devs > /dev/null 2>&1
                if [ "$DUMP_OUTPUT" = true ]; then
-                       ./$seq 2>&1 | tee $tmp.out
+                       _run_seq 2>&1 | tee $tmp.out
                        # Because $? would get tee's return code
                        sts=${PIPESTATUS[0]}
                else
-                       ./$seq >$tmp.out 2>&1
+                       _run_seq >$tmp.out 2>&1
                        sts=$?
                fi
 
@@ -758,15 +786,20 @@ for section in $HOST_OPTIONS_SECTIONS; do
                        _dump_err_cont "[failed, exit status $sts]"
                        _test_unmount 2> /dev/null
                        _scratch_unmount 2> /dev/null
+                       rm -f ${RESULT_DIR}/require_test*
+                       rm -f ${RESULT_DIR}/require_scratch*
                        err=true
                else
                        # the test apparently passed, so check for corruption
                        # and log messages that shouldn't be there.
                        _check_filesystems
                        _check_dmesg || err=true
-                       _check_kmemleak || err=true
                fi
 
+               # Scan for memory leaks after every test so that associating
+               # a leak to a particular test will be as accurate as possible.
+               _check_kmemleak || err=true
+
                # test ends after all checks are done.
                $timestamp && _timestamp
                stop=`_wallclock`